Imports System.Xml

Public Class Form1

    Private publickey = "YOURPUBLICKEYHERE"
    Private privatekey = "YOURPRIVATEKEYHERE"
    Private username = "YOURUSERNAMEHERE"
    Private password = "PASSWORDFORUSERHERE"

    Private Function encrypt(ByVal password As String, ByVal key As String) As String
        Dim result As String
        Dim thischar As String
        Dim keychar As String
        Dim startchar As Integer

        result = ""
        For i As Integer = 0 To password.Length - 1 Step 1
            thischar = password.Substring(i, 1)
            startchar = (i Mod key.Length) - 1
            If startchar < 0 Then
                startchar = key.Length + startchar
            End If
            keychar = key.Substring(startchar, 1)
            thischar = (Asc(thischar) + Asc(keychar)).ToString + "|"
            result += thischar
        Next

        Return result

    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim imsService As New IMSService.IMSServiceService()
        Dim result As String
        Dim xmlResult As New Xml.XmlDataDocument

        result = imsService.getQuote(publickey, username, encrypt(password, privatekey), 1, "ALL", "ND", "D", "L", "B", "ALL", "DV/HC", "NEW YORK, NY", "CHICAGO, IL", "", "", "N", "N", "N")
        xmlResult.LoadXml(result)

        trv.Nodes.Clear()
        trv.Nodes.Add(New TreeNode(xmlResult.DocumentElement.Name))
        Dim tNode As New TreeNode()
        tNode = trv.Nodes(0)

        AddNode(xmlResult.DocumentElement, tNode)
        trv.ExpandAll()

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim imsService As New IMSService.IMSServiceService()
        Dim result As String
        Dim xmlResult As New Xml.XmlDataDocument

        Dim encpass = encrypt(password, privatekey)

        result = imsService.locEmpties(publickey, username, encrypt(password, privatekey), "07724")
        xmlResult.LoadXml(result)

        trv.Nodes.Clear()
        trv.Nodes.Add(New TreeNode(xmlResult.DocumentElement.Name))
        Dim tNode As New TreeNode()
        tNode = trv.Nodes(0)

        AddNode(xmlResult.DocumentElement, tNode)
        trv.ExpandAll()
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim imsService As New IMSService.IMSServiceService()
        Dim result As String
        Dim xmlResult As New Xml.XmlDataDocument

        Dim encpass = encrypt(password, privatekey)

        result = imsService.locSearch(publickey, username, encrypt(password, privatekey), "a")
        xmlResult.LoadXml(result)

        trv.Nodes.Clear()
        trv.Nodes.Add(New TreeNode(xmlResult.DocumentElement.Name))
        Dim tNode As New TreeNode()
        tNode = trv.Nodes(0)

        AddNode(xmlResult.DocumentElement, tNode)
        trv.ExpandAll()
    End Sub

    Private Sub AddNode(ByRef inXmlNode As XmlNode, ByRef inTreeNode As TreeNode)
        Dim xNode As XmlNode
        Dim tNode As TreeNode
        Dim nodeList As XmlNodeList
        Dim i As Integer

        ' Loop through the XML nodes until the leaf is reached.
        ' Add the nodes to the TreeView during the looping process.
        If inXmlNode.HasChildNodes() Then
            nodeList = inXmlNode.ChildNodes
            For i = 0 To nodeList.Count - 1
                xNode = inXmlNode.ChildNodes(i)
                inTreeNode.Nodes.Add(New TreeNode(xNode.Name))
                tNode = inTreeNode.Nodes(i)
                AddNode(xNode, tNode)
            Next
        Else
            ' Here you need to pull the data from the XmlNode based on the
            ' type of node, whether attribute values are required, and so forth.
            inTreeNode.Text = (inXmlNode.OuterXml).Trim
        End If
    End Sub

End Class
